#include <amxmodx>
#include <amxmisc>
#include <fun>
#include <engine>
#include <fakemeta>
#include <cstrike>
#include <hamsandwich>

new const PLUGIN[]	= "Deathrun VIP",
	 VERSION[]	= "1.6",
	  AUTHOR[]	= "Fuffy";

new bool:HealthRegStart[33];

#define IsPlayer(%0)    ( 1 <= %0 <= g_iMaxPlayers )
new g_iMaxPlayers;

#define MAX_DISTANCE 8192.0

new vip_acces_cvar;
new vip_health_cvar;
new vip_reg_cvar;
new vip_dmg_cvar;
new vip_gravity_cvar;
new vip_manager;
new vip_ammo_infinite;

public plugin_init( )
{
	register_plugin
	(
		.plugin_name = PLUGIN, 
		.version     = VERSION, 
		.author      = AUTHOR
	)

	register_clcmd( "say /revive", "ReviveCMD" );
	register_clcmd( "say_team /revive", "ReviveCMD" );
	register_clcmd( "say /vips", "VipsCMD" );
	register_clcmd( "say_team /vips", "VipsCMD" );

	register_clcmd("teleport", "TeleportCMD" );

	RegisterHam( Ham_Spawn, "player", "VIP_Spawn", 1);

	register_event( "Damage", "VIP_Hp", "b", "2!0", "3=0", "4!0" );
	register_event("CurWeapon", "VIP_Speed", "be", "1=1");

	g_iMaxPlayers = get_maxplayers ( )
	RegisterHam ( Ham_TakeDamage, "player", "Player_TakeDamage" );

	vip_acces_cvar = register_cvar( "vip_flags", "ab" );
	vip_health_cvar = register_cvar( "vip_health", "900" );
	vip_reg_cvar = register_cvar( "vip_full_health_delay", "10" );
	vip_dmg_cvar = register_cvar( "vip_damage_multiplier", "3" );
	vip_gravity_cvar = register_cvar( "vip_gravity", "400" );	
	vip_manager = register_cvar( "vip_owner_id", "Privat.");
	vip_ammo_infinite = register_cvar( "vip_infinite_ammo", "1" );
}

public VIP_Spawn( id )
{
	if( is_user_alive( id ) )
	{
		if( is_player_vip( id ) )
		{
			set_task( 3.0, "VIP_Items", id );
			CC(id, "^1[ ^4VIP^1 ] Peste^4 3 secunde^1 vei primi beneficiile de ^3VIP^1 ." );
		}
		else
		{
			set_task(120.0,"vip_pubs",id,_,_,"b",0)
		}
	}	
}

public vip_pubs( id )
{
	new szOwner[ 25 ];
	get_pcvar_string( vip_manager, szOwner, charsmax( szOwner ) );

	if( !is_player_vip( id ) && is_user_connected( id ) )
	{
		CC(id, "^1[ ^4VIP^1 ] Daca vrei sa cumperi ^3VIP^1, da-i add: ^4%s^1 .", szOwner );
		CC(id, "^1[ ^4VIP^1 ] Daca vrei sa vezi jucatorii ^3VIP^1, scrie in chat comanda ^4/vips^1." );
	}
	else
	{
		remove_task( id );
	}
}
public VipsCMD( id )
{
	new Players[32], i, num, VipName[32], buffer[164];
	
	get_players( Players ,num, "c" )
	{
		for( i = 0; i < num; i++ )
		{
			if( is_player_vip(Players[i]) )
			{
				get_user_name( Players[i], VipName, charsmax( VipName ) );
				formatex( buffer, charsmax( buffer ), "<u> <font size = 6> VIP's online</u>:^n ^n </font> <body bgcolor = #383838> </body> <center> <font size = 4 color = #380000 face = WildWest> <b> %s^n </b> </font> </center>", VipName );
				show_motd( id, buffer );
			}
			else
			{
				formatex( buffer, charsmax( buffer ), "<body bgcolor = #383838> <center> <font size = 5 color = 00CC00 face = WildWest> <b> Nu sunt VIP-uri online pe server! </b> </font> </center> </body>", VipName );
				show_motd( id, buffer );
			}
		}
	} 
}

public VIP_Items( id )
{
	if( is_user_alive( id ) )
	{

		set_task(1.0, "iScoreBoard", id + 6969)

		set_user_maxspeed( id, get_user_maxspeed( id ) * 10.0 );

		strip_user_weapons( id )

		set_user_health( id, get_pcvar_num( vip_health_cvar ) );
		set_user_gravity( id, float(get_pcvar_num( vip_gravity_cvar ) ) / 800.0 );

		give_user_weapon( id, CSW_HEGRENADE, _, 10 );
		give_user_weapon( id, CSW_FLASHBANG, _, 10 );
		give_user_weapon( id, CSW_SMOKEGRENADE, _, 10 );

		give_item( id, "weapon_knife" );

		switch( cs_get_user_team( id ) )
		{
			case CS_TEAM_T: give_user_weapon( id, CSW_DEAGLE, 7, 35 );


			case CS_TEAM_CT:
			{
				cs_set_user_model( id, "vip" );

				give_user_weapon( id, CSW_DEAGLE, 7, 35 );
				give_user_weapon( id, CSW_GLOCK18, 20, 120 );
				give_user_weapon( id, CSW_USP, 12, 100 );
				give_user_weapon( id, CSW_M3, 8, 100 );
				give_user_weapon( id, CSW_AWP, 10, 30 );
				give_user_weapon( id, CSW_M4A1, 30, 90 );
				give_user_weapon( id, CSW_AK47, 30, 90 );
			}

			default: return;
		}
	}
}

public plugin_precache()
{
	precache_model( "models/player/vip_glock18.mdl");
	precache_model( "models/player/vip_usp.mdl");
	precache_model( "models/player/vip_deagle.mdl");
	precache_model( "models/player/vip_m3.mdl");
	precache_model( "models/player/vip_awp.mdl");
	precache_model( "models/player/vip_m4a1.mdl");
	precache_model( "models/player/vip_ak47.mdl");
}

public plugin_cfg()
{
	auto_exec_config("deathrun_vip")
}

public iScoreBoard(tID) {
        
        new id = tID - 6969;
        
        message_begin(MSG_ALL, get_user_msgid("ScoreAttrib"));
        write_byte(id);
        write_byte(4);
        message_end();
}

public VIP_Hp( id )
{
	if( !id )
		return PLUGIN_HANDLED;

	if( is_player_vip( id ) )
	{
		if( HealthRegStart[ id ] == false )
		{
			set_task( float( get_pcvar_num( vip_reg_cvar ) ) , "vip_health", id );
			HealthRegStart[ id ] = true;
			return PLUGIN_CONTINUE;
		}

	}
	return PLUGIN_CONTINUE;
}

public vip_health(id)
{
	if( is_user_alive( id ) )
	{
		set_user_health( id, get_pcvar_num( vip_health_cvar ) );
		HealthRegStart[ id ]  = false;
	}
	else
	{
		remove_task( id );
	}
}

public VIP_Speed( id )
{
	if( is_user_alive( id ) && is_player_vip( id ) )
	{

		new Weapon, Ammo, BpAmmo;
		Weapon = get_user_weapon( id, Ammo, BpAmmo );

		if( Ammo <= 1 && get_pcvar_num( vip_ammo_infinite ) >= 1 )
		{
			give_user_weapon( id, Weapon, 40, BpAmmo );
		}

		set_user_maxspeed( id, get_user_maxspeed( id ) * 10.0 );
		set_user_gravity( id, float(get_pcvar_num( vip_gravity_cvar ) ) / 800.0 );

		switch( get_user_weapon( id ) )
		{

			case CSW_GLOCK18:
			{
				set_pev( id, pev_viewmodel2, "models/player/vip_glock18.mdl" );
			}

			case CSW_USP:
			{
				set_pev( id, pev_viewmodel2, "models/player/vip_usp.mdl" );
			}

			case CSW_DEAGLE:
			{
				set_pev( id, pev_viewmodel2, "models/player/vip_deagle.mdl" );
			}

			case CSW_M3:
			{
				set_pev( id, pev_viewmodel2, "models/player/vip_m3.mdl" );
			}

			case CSW_AWP:
			{
				set_pev( id, pev_viewmodel2, "models/player/vip_awp.mdl" );
			}

			case CSW_AK47:
			{
				set_pev( id, pev_viewmodel2, "models/player/vip_ak47.mdl" );
			}

			case CSW_M4A1:
			{
				set_pev( id, pev_viewmodel2, "models/player/vip_m4a1.mdl" );
			}
		}
	
	}
}

public TeleportCMD( iPlayer )
{
	if( is_player_vip( iPlayer ) && is_user_alive( iPlayer ) )
	{
		new Float: vOrigin[ 3 ], Float: vViewOfs[ 3 ], Float: vAngles[ 3 ], Float: vVector[ 3 ];
		entity_get_vector( iPlayer, EV_VEC_origin, vOrigin );
		entity_get_vector( iPlayer, EV_VEC_view_ofs, vViewOfs );
		entity_get_vector( iPlayer, EV_VEC_v_angle, vAngles );
 
		vOrigin[ 0 ] = vOrigin[ 0 ] + vViewOfs[ 0 ];
		vOrigin[ 1 ] = vOrigin[ 1 ] + vViewOfs[ 1 ];
		vOrigin[ 2 ] = vOrigin[ 2 ] + vViewOfs[ 2 ];
     
		angle_vector( vAngles, ANGLEVECTOR_FORWARD, vVector );
     
		vVector[ 0 ] = vVector[ 0 ] * MAX_DISTANCE + vOrigin[ 0 ];
		vVector[ 1 ] = vVector[ 1 ] * MAX_DISTANCE + vOrigin[ 1 ];
		vVector[ 2 ] = vVector[ 2 ] * MAX_DISTANCE + vOrigin[ 2 ];
     
		new pentru = create_tr2( );
		engfunc( EngFunc_TraceLine, vOrigin, vVector, IGNORE_MONSTERS, iPlayer, pentru );
     
		new Float: flFraction;
		get_tr2( pentru, TR_flFraction, flFraction );
     
		if( flFraction < 1.0 )
 		{
			new iEntityHit;
			get_tr2( pentru, TR_pHit, iEntityHit );
         
 			if( iEntityHit == 0 )
 			{
				new Float: vEndPos[ 3 ];
				get_tr2( pentru, TR_vecEndPos, vEndPos );
             
  				if( point_contents( vEndPos ) != CONTENTS_SKY )
  				{
  					new Float: vPlane[ 3 ];
					get_tr2( pentru, TR_vecPlaneNormal, vPlane );
                 
					vEndPos[ 0 ] = vEndPos[ 0 ] + vPlane[ 0 ] * 40.0;
					vEndPos[ 1 ] = vEndPos[ 1 ] + vPlane[ 1 ] * 40.0;
					vEndPos[ 2 ] = vEndPos[ 2 ] + vPlane[ 2 ] * 40.0;
                 
					entity_set_origin( iPlayer, vEndPos );
					return PLUGIN_HANDLED;
                 
				}
			}
		}
     
		free_tr2( pentru );
	}
	return PLUGIN_HANDLED;
}


public Player_TakeDamage ( iVictim, iInflictor, iAttacker, Float:fDamage ) 
{
    
	if ( iInflictor == iAttacker && IsPlayer ( iAttacker ) && is_player_vip( iAttacker ) ) 
	{
		SetHamParamFloat ( 4, fDamage * float( get_pcvar_num( vip_dmg_cvar ) ) );
		return HAM_HANDLED;
        
	}
    	return HAM_IGNORED;
    
}

public ReviveCMD( id )
{
	if( is_user_alive( id ) )
	{
		CC( id, "!n[ !vVIP!n ] Numai jucatorii morti pot folosi aceasta comanda!" );
		return PLUGIN_HANDLED;
	}

	if( !is_player_vip( id ) )
	{
		CC(id, "!n[ !vVIP!n ] Numai daca esti !eVIP!n poti folosi aceasta comanda!" );
		return PLUGIN_HANDLED;
	}
	
	ExecuteHam( Ham_CS_RoundRespawn, id );
	return PLUGIN_HANDLED;
	
}

public client_putinserver( id )
{
	new szName[ 32 ];
	get_user_name( id, szName, charsmax( szName ) );

	if( is_player_vip( id ) )
	{
		CC(0, "!V[ !e%s !n%s !v] !nVIP-ul !v%s!n s-a connectat de pe server!", PLUGIN, VERSION, szName );
	}
}

public client_disconnect( id )
{
	new szName[ 32 ];
	get_user_name( id, szName, charsmax( szName ) );

	if( is_player_vip( id ) )
	{
		CC(0, "!V[ !e%s !n%s !v] !nVIP-ul !v%s!n s-a deconnectat de pe server!", PLUGIN, VERSION, szName );
	}
}

bool:is_player_vip( id )
{
	new szVIP[ 60 ];
	get_pcvar_string( vip_acces_cvar, szVIP, charsmax( szVIP ) - 1 );

	if( has_all_flags( id, szVIP ) )
	{
		return true;
	}
	return false;
}

CC(const id, const input[], any:...)
{
	new count = 1, players[32]
	static msg[191]
	vformat(msg, 190, input, 3)
	
	replace_all(msg, charsmax(msg), "!v", "^4")
	replace_all(msg, charsmax(msg), "!n", "^1")
	replace_all(msg, charsmax(msg), "!e", "^3")
	
	if (id) players[0] = id; else get_players(players, count, "ch")
	{
		for (new i = 0; i < count; i++)
		{
			if (is_user_connected(players[i]))
			{
				message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), _, players[i])
				write_byte(players[i]);
				write_string(msg);
				message_end();
			}
		}
	}
}

auto_exec_config(const szName[], bool:bAutoCreate=true) 
{ 
    new szFileName[32] 
    new iLen = copy(szFileName, charsmax(szFileName), szName) 
    if( iLen <= 4 || !equal(szFileName[iLen-4], ".cfg") ) 
    { 
        add(szFileName, charsmax(szFileName), ".cfg") 
    } 

    new szConfigPath[96] 
    get_localinfo("amxx_configsdir", szConfigPath, charsmax(szConfigPath)) 
    format(szConfigPath, charsmax(szConfigPath), "%s/%s", szConfigPath, szFileName) 

    if( file_exists(szConfigPath) ) 
    { 
        server_cmd("exec %s", szConfigPath) 
        server_exec() 
        return 1 
    } 
    else if( bAutoCreate ) 
    { 
        new fp = fopen(szConfigPath, "wt") 
        if( !fp ) 
        { 
            return -1 
        } 
        new szPluginFileName[96], szPluginName[64], szAuthor[32], szVersion[32], szStatus[2] 
        new iPlugin = get_plugin(-1,  
                    szPluginFileName, charsmax(szPluginFileName),  
                    szPluginName, charsmax(szPluginName),  
                    szVersion, charsmax(szVersion),  
                    szAuthor, charsmax(szAuthor),  
                    szStatus, charsmax(szStatus) ) 

        server_print("Plugin id is %d", iPlugin) 
        fprintf(fp, "; ^"%s^" configuration file^n", szPluginName) 
        fprintf(fp, "; Author : ^"%s^"^n", szAuthor) 
        fprintf(fp, "; Version : ^"%s^"^n", szVersion) 
        fprintf(fp, "; File : ^"%s^"^n", szPluginFileName) 

        new iMax, i, szCommand[64], iCommandAccess, szCmdInfo[128], szFlags[32] 
        iMax = get_concmdsnum(-1, -1) 
        fprintf(fp, "^n; Console Commands :^n") 
        for(i=0; i<iMax; i++) 
        { 
            if( get_concmd_plid(i, -1, -1) == iPlugin ) 
            { 
                get_concmd(i,  
                        szCommand, charsmax(szCommand),  
                        iCommandAccess,  
                        szCmdInfo, charsmax(szCmdInfo),  
                        -1, -1) 
                get_flags(iCommandAccess, szFlags, charsmax(szFlags)) 
                fprintf(fp, "; %s | Access:^"%s^" | ^"%s^"^n", szCommand, szFlags, szCmdInfo) 
            } 
        } 

        iMax = get_plugins_cvarsnum() 
        new iTempId, iPcvar, szCvarName[256], szCvarValue[128] 
        fprintf(fp, "^n; Cvars :^n") 
        for(new i; i<iMax; i++) 
        { 
            get_plugins_cvar(i, szCvarName, charsmax(szCvarName), _, iTempId, iPcvar) 
            if( iTempId == iPlugin ) 
            { 
                get_pcvar_string(iPcvar, szCvarValue, charsmax(szCvarValue)) 
                fprintf(fp, "%s ^"%s^"^n", szCvarName, szCvarValue) 
            } 
        } 

        fclose(fp) 
    } 
    return 0 
}    


give_user_weapon( index , iWeaponTypeID , iClip=0 , iBPAmmo=0 )
{
    if( !( CSW_P228 <= iWeaponTypeID <= CSW_P90 ) || ( iClip < 0 ) || ( iBPAmmo < 0 ) || !is_user_alive( index ) )
        return -1;
    
    new GrenadeBits = ( ( 1 << CSW_HEGRENADE ) | ( 1 << CSW_FLASHBANG ) | ( 1 << CSW_SMOKEGRENADE ) );
    new szWeaponName[ 20 ] , iWeaponEntity;
    get_weaponname( iWeaponTypeID , szWeaponName , charsmax( szWeaponName ) );
    
    if ( ( iWeaponEntity = user_has_weapon( index , iWeaponTypeID ) ? find_ent_by_owner( -1 , szWeaponName , index ) : give_item( index , szWeaponName ) ) > 0 )
    {
        if ( !( GrenadeBits & ( 1 << iWeaponTypeID ) ) )
            cs_set_weapon_ammo( iWeaponEntity , iClip );
        
        cs_set_user_bpammo( index , iWeaponTypeID , iBPAmmo ); 
    }
    
    return iWeaponEntity;
}